class CountdownPlus{
    constructor(uid) {
        this.wrapper = false;
        this.numbersWrapper = false;

        this.seconds = 0
        this.minutes = 0
        this.hours = 0
        this.days = 0
        this.textBefore = false
        this.textAfter = false
        this.endDate = new Date().getTime();
        this.endTime =
        this.interval = null
        this.wrapper = false
        this.uid = uid
        this.selectors = {
            wrapper:'[data-dzm-cdp-wrapper="'+uid+'"]',
            numbersWrapper:'[data-dzm-cdp-numbers-wrapper="'+uid+'"]',
            secondSelector:'[data-dzm-cdp-seconds="'+uid+'"]',
            minuteSelector:'[data-dzm-cdp-minutes="'+uid+'"]',
            hourSelector:'[data-dzm-cdp-hours="'+uid+'"]',
            daySelector:'[data-dzm-cdp-days="'+uid+'"]',
            textBefore:'[data-dzm-cdp-text-before="'+uid+'"]',
            textAfter:'[data-dzm-cdp-text-after="'+uid+'"]',
        }
    }

    init(options){
        console.log('init CountdownPlus',options);
        if((this.wrapper = document.querySelector(this.selectors.wrapper)) == null){
            console.error('no countdown wrapper')
            return
        }
        if((this.numbersWrapper = document.querySelector(this.selectors.numbersWrapper)) == null){
            console.error('no numbers wrapper')
            return
        }
        if((this.seconds = document.querySelector(this.selectors.secondSelector)) == null){
            console.error('no seconds wrapper')
            return
        }
        if((this.minutes = document.querySelector(this.selectors.minuteSelector)) == null){
            console.error('no minutes wrapper')
            return
        }
        if((this.hours = document.querySelector(this.selectors.hourSelector)) == null){
            console.error('no hours wrapper')
            return
        }
        if((this.days = document.querySelector(this.selectors.daySelector)) == null){
            console.error('no days wrapper')
            return
        }

        if((this.textBefore = document.querySelector(this.selectors.textBefore)) == null){
            console.error('no days wrapper')
            return
        }

        if((this.textAfter = document.querySelector(this.selectors.textAfter)) == null){
            console.error('no days wrapper')
            return
        }

        if(!options.type){
            console.error('no type set',options)
            return
        }

        let endDate = new Date();
        if(options.type === 'static'){
            if(!options.endDate ){
                console.error('No enddate set', options);
                return
            }
            endDate = options.endDate
        }else{
            if(!options.endTime ){
                console.error('No endTime set', options);
                return
            }
            let today = endDate
            console.log(today)

            switch (today.getDay()){
                case 0:
                    if(options.repeatSunday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                case 1:
                    if(options.repeatMonday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                case 2:
                    if(options.repeatTuesday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                case 3:
                    if(options.repeatWednesday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                case 4:
                    if(options.repeatThursday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                case 5:
                    if(options.repeatFriday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                case 6:
                    if(options.repeatSaturday == 0)
                        today=new Date(today.getDate() - 1)
                    break;
                default:
                    break;


            }
            console.log(today)
            endDate = new Date(today.getFullYear()+'-'+((today.getMonth()+1) <=9 ? '0'+(today.getMonth()+1) : (today.getMonth()+1)) + '-' + ((today.getDate()) <=9 ? '0'+(today.getDate()) : (today.getDate())) + ' ' + options.endTime + ':00')

        }



            this.interval = setInterval(()=>{
                let now = new Date().getTime();


                //now += 60000
                const distance = new Date(endDate)-now;




                const days = Math.floor(distance / (1000 * 60 * 60 * 24));
                const hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                const minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
                const seconds = Math.floor((distance % (1000 * 60)) / 1000);

                this.days.innerHTML = (days < 0 ? '00' : String(days).padStart(2, '0'))+options.daySuffix;
                this.hours.innerHTML = (hours < 0 ? '00' : String(hours).padStart(2, '0'))+options.hourSuffix;
                this.minutes.innerHTML = (minutes < 0 ? '00' : String(minutes).padStart(2, '0'))+options.minuteSuffix;
                this.seconds.innerHTML = (seconds < 0 ? '00' : String(seconds).padStart(2, '0'))+options.secondSuffix;

                // Hide elements if they are zero
                if (days <= 0 && options.hideExpiredElements) {
                    this.days.style.display = 'none';
                } else {
                    this.days.style.display = 'inline';
                }

                if (days <= 0 && hours <= 0 && options.hideExpiredElements) {
                    this.hours.style.display = 'none';
                } else {
                    this.hours.style.display = 'inline';
                }

                if ( days <= 0 && hours <= 0 && minutes <= 0 && options.hideExpiredElements) {
                    this.minutes.style.display = 'none';
                } else {
                    this.minutes.style.display = 'inline';
                }
                /*if (days <= 0 && hours <= 0 && minutes <= 0 && seconds <= 0 ) {
                    this.seconds.style.display = 'none';
                } else {
                    this.seconds.style.display = 'inline';
                }*/


                if(distance <= 0 ){
                    // TIMER EXPIRED
                    if(options.expiredStyle === 'hide'){
                        this.wrapper.style.display = 'none'
                        this.wrapper.classList.add('d-none')
                        this.wrapper.classList.remove('d-flex')
                    }else if(options.expiredStyle === 'hideTimer'){
                        this.numbersWrapper.classList.add('d-none')
                        this.numbersWrapper.classList.remove('d-flex')
                        this.textAfter.style.display = 'none'
                        this.textBefore.innerText = options.textExpired
                    }else{
                        this.textBefore.innerHTML = options.textBeforeExpired + '&nbsp;'
                        this.textAfter.innerHTML = '&nbsp;' + options.textAfterExpired

                    }
                    clearInterval(this.interval)
                }

            },100)

    }
}