class CountDown{


    constructor(uid) {

        this.endDate = "";
        this.seconds = "";
        this.minutes = "";
        this.hours = "";
        this.days = "";
        this.overlay="";
        this.distance = -1;
        this.uid = uid
        this.selectors={
            secondSelector:'[data-dzm-scd-second-selector="'+uid+'"]',
            minuteSelector:'[data-dzm-scd-minute-selector="'+uid+'"]',
            hourSelector:'[data-dzm-scd-hour-selector="'+uid+'"]',
            daySelector:'[data-dzm-scd-day-selector="'+uid+'"]',
            overlaySelector:'[data-dzm-scd-overlay="'+uid+'"]',

        }
        this.endDate = new Date()
        this.interval = null

    }

    init(){
        this.seconds = document.querySelector(this.selectors.secondSelector)
        this.minutes = document.querySelector(this.selectors.minuteSelector)
        this.hours = document.querySelector(this.selectors.hourSelector)
        this.days = document.querySelector(this.selectors.daySelector)
        this.overlay = document.querySelector(this.selectors.overlaySelector)
        this.endDate = new Date()
        this.interval = null
    }
    start(endDate){
        if(this.interval !== null){
            clearInterval(this.interval)

        }

        // Update the count down every 1 second
        this.interval = setInterval(() =>{
            // Get today's date and time

            const now = new Date().getTime();
            // Find the distance between now and the end date
            const distance = new Date(endDate) - now;

            // Time calculations for days, hours, minutes and seconds
            const days = Math.floor(distance / (1000 * 60 * 60 * 24));
            const hours = Math.floor(
                (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)
            );
            const minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
            const seconds = Math.floor((distance % (1000 * 60)) / 1000);


            // Output the result in <div> tags
            this.days.innerHTML = days;
            this.hours.innerHTML = hours;
            this.minutes.innerHTML = minutes;
            this.seconds.innerHTML = seconds;
            this.overlay.innerHTML = "";
            // If the count down is finished, write some text
            if (distance < 0) {
                clearInterval(this.interval);
                this.overlay.innerHTML = "Angebot abgelaufen";
                this.days.innerHTML = 0;
                this.hours.innerHTML = 0;
                this.minutes.innerHTML = 0;
                this.seconds.innerHTML = 0;
            }
        }, 100);
    }
}